package it.soltec.ibox.esignal;

import com.neva.COMClassObject;
import com.neva.COMHResult;
import com.neva.COMIConnectionPoint;
import com.neva.COMIConnectionPointContainer;
import com.neva.COMSafeArray;
import com.neva.COMStdDispatch;
import com.neva.GUID;
import com.neva.*;

public class UseHooks implements _IHooksEvents_If{
	public IHooks m_object;
	private COMIConnectionPoint m_cp;
	private COMStdDispatch m_dspSink;
	public int m_cpCookie;
    public COMIConnectionPointContainer cpc;

	public UseHooks() throws Exception {
		createObject();
	}

	private void createObject() throws Exception{
		m_object = new IHooks();
		GUID clsid = GUID.CLSIDFromProgID("IESignal.Hooks");
        //m_object.CoCreateInstance(clsid,COMClassObject.LOCAL_SERVER);
        //m_object.CoCreateInstance(clsid);
        m_object.CoCreateInstance("IESignal.Hooks");
		cpc = new COMIConnectionPointContainer();
		m_object.QueryInterface(cpc);
		m_cp = cpc.FindConnectionPoint(_IHooksEvents_If.IID);
		cpc.Release();
		m_dspSink = _IHooksEvents.BuildDispinterfaceSink(this);
		m_cpCookie = m_cp.Advise(m_dspSink);
        //m_object.addbro

        m_object.SetBrokerName("IntesaTrade T3");
        m_object.AddBrokerCategory("Trade", "Trade");
        m_object.AddBrokerTradeMenuCommand("Trade", "Trade");
        m_object.AddBrokerContextMenuCommand("Trade", "Trade", "Trade");

		System.out.println(m_object.GetGetAppBuildNumber());
		System.out.println(m_object.GetGetAppVersion());
		System.out.println(m_object.GetGetAppTime());
	}

    private static UseHooks useHooks = null;
	public static void main(String[] args) {
		try {
			COMClassObject.CoInitialize(COMClassObject.MULTITHREADED);
			useHooks = new UseHooks();
            try {
                //useHooks.m_object.AttachToActiveObject("IESignal.Hooks");
                useHooks.m_object.AttachToActiveObject("IESignal.Hooks");
            } catch (Exception e) {
                useHooks.m_object.AttachDispatch("IESignal.Hooks");
            }
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(0);
		}
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnSymbolChanged(java.lang.String)
	 */
	public COMHResult OnSymbolChanged(String _sSymbol) {
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnQuoteChanged(java.lang.String)
	 */
	public COMHResult OnQuoteChanged(String _sSymbol) {
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnBarsChanged(int)
	 */
	public COMHResult OnBarsChanged(int _lHandle) {
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnBarsReceived(int)
	 */
	public COMHResult OnBarsReceived(int _lHandle) {
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnPlaceOrder(java.lang.String)
	 */
	public COMHResult OnPlaceOrder(String _sXML) {
		System.out.println("OnPlaceOrder:\n\n\n" + _sXML);
        try {
            int pof = m_object.GetXMLToPlaceOrderFlag(_sXML);
            long nItems = m_object.GetXMLGetNumOrderItems(_sXML);
            System.out.println("pof: " + pof);
            System.out.println("nItems: " + nItems);
            for (int i = 0 ; i<nItems; i++) {
                System.out.println(m_object.GetXMLGetOrderItem(_sXML, i));
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnCancelAllOrders()
	 */
	public COMHResult OnCancelAllOrders() {
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnCancelOrderByOrderID(java.lang.String)
	 */
	public COMHResult OnCancelOrderByOrderID(String _sOrderID) {
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnCancelOrder(java.lang.String)
	 */
	public COMHResult OnCancelOrder(String _sSymbol) {
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnClosePosition(java.lang.String)
	 */
	public COMHResult OnClosePosition(String _sSymbol) {
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnCloseAllPositions()
	 */
	public COMHResult OnCloseAllPositions() {
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnCancelAndReplace(java.lang.String, double, double, double)
	 */
	public COMHResult OnCancelAndReplace(String _sOrderID, double _dQuantity, double _dLimitPrice, double _dStopPrice) {
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnTimeSalesChanged(int)
	 */
	public COMHResult OnTimeSalesChanged(int _lHandle) {
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnWindowOpen(int, int, int)
	 */
	public COMHResult OnWindowOpen(int _hWND, int _hParentWnd, int _wtf) {
		System.out.println("OnWindowOpen");
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnWindowClosing(int, int, int)
	 */
	public COMHResult OnWindowClosing(int _hWND, int _hParentWnd, int _wtf) {
		System.out.println("OnWindowClosing");
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnWindowPosChanging(int, int, int)
	 */
	public COMHResult OnWindowPosChanging(int _hWND, int _hParentWnd, int _wtf) {
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnSavingLayoutOrPage(java.lang.String)
	 */
	public COMHResult OnSavingLayoutOrPage(String _sLayout) {
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnLoadingLayoutOrPage(java.lang.String)
	 */
	public COMHResult OnLoadingLayoutOrPage(String _sLayout) {
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnAppClosing()
	 */
	public COMHResult OnAppClosing() {
		System.out.println("OnAppClosing");
        try {
            useHooks.m_cp.Unadvise(m_cpCookie);
            useHooks.cpc.Release();
            useHooks.m_object.Release();
            COMClassObject.CoUninitialize();
        } catch (COMException ex) {
            ex.printStackTrace();
        }
        System.exit(0);
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnSymbolGroupChangeEvent(java.lang.String, int, int)
	 */
	public COMHResult OnSymbolGroupChangeEvent(String _sSymbol, int _lGroupNum, int _crGroupColor) {
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnIntervalGroupChangeEvent(java.lang.String, int, int)
	 */
	public COMHResult OnIntervalGroupChangeEvent(String _sSymbol, int _lGroupNum, int _crGroupColor) {
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnWindowSymbolChange(int, int, java.lang.String, int)
	 */
	public COMHResult OnWindowSymbolChange(int _hWND, int _hParentWnd, String _sSymbol, int _wtf) {
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnBrokerMainMenuCommand(java.lang.String)
	 */
	public COMHResult OnBrokerMainMenuCommand(String _sMenuCommandKey) {
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnBrokerContextMenuCommand(java.lang.String, com.neva.COMSafeArray[])
	 */
	public COMHResult OnBrokerContextMenuCommand(String _sContextCommandKey, COMSafeArray[] _ppsaRowKeys) {
		return null;
	}

	/* (non-Javadoc)
	 * @see it.soltec.ibox.esignal._IHooksEvents_If#OnBrokerRowDblClick(java.lang.String, java.lang.String)
	 */
	public COMHResult OnBrokerRowDblClick(String _sCategoryKey, String _sRowKey) {
		return null;
	}
}
